/* clasha.c - classes for pure C by Shaos (optional functions)

 Copyright (c) 2007,2014 A.A.Shabarshin <me@shaos.net>

 Permission is hereby granted, free of charge, to any person obtaining
 a copy of this software and associated documentation files (the "Software"),
 to deal in the Software without restriction, including without limitation
 the rights to use, copy, modify, merge, publish, distribute, sublicense,
 and/or sell copies of the Software, and to permit persons to whom
 the Software is furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.

*/

#include <stdio.h>
#include <stdlib.h>

/* TODO: implement proper map here */

#define MAX_CLASSES 256

int registered_classes = 0;

struct registered_deletes
{
  int h;
  void(*f)(void*);
} deletes[MAX_CLASSES];

void register_class(int h,void(*f)(void*))
{
  int i;
  if(!registered_classes)
  {
    for(i=0;i<MAX_CLASSES;i++)
    {
      deletes[i].h = 0;
      deletes[i].f = 0;
    }
  }
  i = h&0xFF;
  if(deletes[i].h)
  {
    if(deletes[i].h!=h)
    {
      printf("ERROR: Collision detected!\n");
      exit(-2);
    }
    if(deletes[i].f!=f)
    {
      printf("ERROR: Attempt to register wrong function!\n");
      exit(-3);
    }
  }
  else
  {
    deletes[i].f = f;
    deletes[i].h = h;
    registered_classes++;
  }
}

void common_delete(void *p)
{
 int *h = (int*)p;
 int i = (*h)&0xFF;
 if(deletes[i].h!=(*h))
 {
   printf("ERROR: Attempt to delete unknown object!\n");
   exit(-4);
 }
 deletes[i].f(p);
}
